﻿<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Print Map</title>
    <style type="text/css">
        .style1
        {
            height: 75px;
            background-color: #eaeaea;
        }
        .container
        {
            border: 1px solid #a6a6a6;
        }
        .container ul
        {
            padding: 0px;
        }
        .container li
        {
            list-style-type: none;
        }
        
        .bulletcont
        {
            list-style-type: none;
            float: left;
            padding: 1px;
            width: 21px;
            margin:0px;
        }
        .bulletdesk
        {
            margin-left: 0px; 
        }
        .bullet
        {
            background: url(imgs/Depart-Arive-icon.png) no-repeat;
            list-style-type: none;
            margin-left: 10px;
            width: 22px;
            height: 22px;
            text-align: center;
        }
        .bullet span
        {
            font-family: Arial, Helvetica, sans-serif;
            font-weight: bold;
            color: #FFFFFF;
            font-size: 14px;
            text-align: center;
            display: block;
            padding: 2px 1px 0px 0px;
        }
        .departhead
        {
            text-transform: uppercase;
            font-size: 11px;
            font-family: Arial, Helvetica, sans-serif;
            padding-left: 40px;
        }
        .desc
        {
            font-family: Arial, Helvetica, sans-serif;
            font-size: 11px;
            font-weight: bold;
            padding-left: 40px;
        }
    </style>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <script type="text/javascript" src="https://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=7.0&s=1"></script>
	<script src="../../ClientGlobalContext.js.aspx" type="text/javascript"></script>
	<script src="/Webresources/a422_jquery.js" type="text/javascript"></script>
	<script src="/Webresources/a422_json2.js" type="text/javascript"></script>
</head>
<body onload="LoadFrames();">
    <script language="javascript" type="text/javascript">
        var routeString = "";
        var Bingkey = "AidouiG_1BA_oZJPRHKw6s7c8F7wJzJJmquPv8gUcqfoxlkvtgT-ZSDjWsVq6hct"; //AdmissionLab Key
        var alertMsg = '';
        //var MM = Microsoft.Maps;
        var map = null;
        var addressList = new Array();
        var orgList = new Array();
        var tripId;
        var alphabets = new Array("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
        /*function GetAddresses1() {
            addressList[0] = "Barking Station";
            addressList[1] = "IG3 8LQ,London";
            addressList[2] = "Ilford Station";
            orgList[0] = "JK University";
            orgList[1] = "Oxford University";
            orgList[2] = "Essex University";
        }*/
        function LoadFrames() {
            /*var query = window.location.search.substring(1);
            var parms = query.split('&');
            for (var i = 0; i < parms.length; i++) {
                //alert(parms[i]);
                var pos = parms[i].indexOf('=');
                if (pos > 0) {
                    var key = parms[i].substring(0, pos);
                    var val = parms[i].substring(pos + 1);
                    //return val;
                    if (i == 0) {
                        routeString = val;
                        routeString = routeString.replace(/~/g, "&");
                    }
                    else {
                        tripId = val;
                    }

                }
            }*/
            GetAddresses();
			
			for (var i = 0; i < addressList.length; i++) {
				routeString = routeString + "wp." + i + "=" + addressList[i] + "&";
			}
			
			var url = "https://dev.virtualearth.net/REST/v1/Imagery/Map/Road/Routes?" + routeString + "&mapVersion=v1&mapSize=658,515&zoomLevel=15&key=" + Bingkey;
            document.getElementById('frame1').src = url;
			
            MakeRouteRequest();
        }

		//function to read the Trip id from Query string.
		function GetTripId() {
            var query = window.location.search.substring(1);
			query = decodeURIComponent(query);
			var name = "Data";
			if (query.indexOf("?") == 0) { query = query.substr(1); }
			var pairs = query.split("&");
			for (var i = 0; i < pairs.length; i++) {
				var pair = pairs[i].split("=");
				if (pair[0] == name) {
					return pair[1];
				}
			}
			return "";
        }
		
		//Use web services to get addresses for the trip
		function GetAddresses()
		{
		//Get trip ID from qs
		tripId = GetTripId();
		
		//Call Web Service to get addresses
		if (tripId != null && tripId != undefined) 
			{
			var context = GetGlobalContext();
			var serverUrl = context.getServerUrl();
			var ODataPath = serverUrl + "/XRMServices/2011/OrganizationData.svc";
			//Query to get data for related activities
			var ODataQuery = ODataPath + "/A422_eventSet?$select=A422_Address,A422_name,a422_organizationid&$filter=a422_tripid/Id eq guid'" + tripId + "'&$orderby=A422_StartDateTime asc";
			
			$.ajax({
			   type: "GET",
			   contentType: "application/json; charset=utf-8",
			   datatype: "json",
			   async: false,
			   url: ODataQuery,
			   beforeSend: function (XMLHttpRequest) { XMLHttpRequest.setRequestHeader("Accept", "application/json"); },
			   success: function (data, textStatus, XmlHttpRequest)
				   {
						var results = data.d.results;
						var msg = "";
						var j = 0;
						//debugger
						for (i = 0; i < results.length; i++) {
							if (results[i].A422_Address != null && results[i].A422_Address != undefined) {
								addressList[j] = results[i].A422_Address;
								orgList[i] = results[i].a422_organizationid.Id;
								j++;
							}
						}
				   },
				   error: function (XmlHttpRequest, textStatus, errorThrown) { document.write('Travel Event call failed: ' + ODataQuery); }
				   });
			}
		}

        function MakeRouteRequest() {
            //var routeString = '';
            var routeRequest = "https://dev.virtualearth.net/REST/v1/Routes?" + routeString + "routePathOutput=Points&output=json&jsonp=RouteCallback&key=" + Bingkey;
            CallRestService(routeRequest);
        }
        function RouteCallback(result) {

            if (result &&
                   result.resourceSets &&
                   result.resourceSets.length > 0 &&
                   result.resourceSets[0].resources &&
                   result.resourceSets[0].resources.length > 0) {

                // Draw the route
                var routeline = result.resourceSets[0].resources[0].routePath.line;
                var routepoints = new Array();

                for (var i = 0; i < routeline.coordinates.length; i++) {

                    routepoints[i] = new Microsoft.Maps.Location(routeline.coordinates[i][0], routeline.coordinates[i][1]);
                }

                //Draw the instructions-points
                var directions; // = result.resourceSets[0].resources[0].routeLegs[0].itineraryItems;
                var totalDistance = 0.0;
                var totalTime = 0.0;
                var alertMsg = '';
                var ind = 0;
                var tripLocs = result.resourceSets[0].resources[0].routeLegs.length;
                //debugger
                alertMsg = alertMsg + '<table style="width:100%;font-family: Arial; font-size:11px;" class="container">';
                for (var x = 0; x < result.resourceSets[0].resources[0].routeLegs.length; x++) {
                    var twoLocsDistance = 0.0;
                    var twoLocsTime = 0.0;
                    var directionsMsg = '';

                    alertMsg = alertMsg + '<tr><td  class="style1" colspan="2" align="left"><ul class="bulletcont"><li class="bullet"><span>' + alphabets[x] + '</span></li></ul><ul class="bulletdesk"><li class="departhead">DEPART:</li><li class="desc">' + orgList[x] + '</li><li class="desc">' + addressList[x] + '</li></ul></td></tr>';
                    directions = result.resourceSets[0].resources[0].routeLegs[x].itineraryItems
                    for (var i = 0; i < directions.length; i++) {
                        var indDirDistance;
                        if (directions[i].travelDistance.toFixed(1) == 0.0) {
                            indDirDistance = directions[i].travelDistance.toFixed(2);
                        }
                        else
                            indDirDistance = directions[i].travelDistance.toFixed(1);

                        if (i + 1 == directions.length)
                            directionsMsg = directionsMsg + '<tr><td colspan="2"><br /><a style="color:Green; padding-right:1px">' + (ind + 1).toString() + '.</a>' + directions[i].instruction.text + '</td></tr>';
                        else
                            directionsMsg = directionsMsg + '<tr><td><br /><a style="color:Green; padding-right:1px">' + (ind + 1).toString() + '.</a>' + directions[i].instruction.text + '</td><td align="right"><a>' + '(' + indDirDistance + ' mi)</a></td></tr>';
                        //directionsMsg = directionsMsg + (ind + 1).toString() + "." + directions[i].instruction.text + "(" + indDirDistance + "mi)<br><br>";
                        //directionsMsg = directionsMsg + '<tr><td><br /><a style="color:Green; padding-right:1px">' + (ind + 1).toString() + '.</a>' + directions[i].instruction.text + '<a style="padding-left:100px">'+ '(' + indDirDistance + ' mi)</a></td></tr>';
                        totalDistance = totalDistance + parseFloat(directions[i].travelDistance);
                        totalTime = totalTime + parseFloat(directions[i].travelDuration);
                        twoLocsDistance = twoLocsDistance + parseFloat(directions[i].travelDistance);
                        twoLocsTime = twoLocsTime + parseFloat(directions[i].travelDuration);
                        ind++;
                    }
                    alertMsg = alertMsg + '<tr><td colspan="2"><a style="color:Green">' + alphabets[x] + '-' + alphabets[x + 1] + ':</a>' + twoLocsDistance.toFixed(1) + ' mi<a style="color:Green; padding-left:10px">Estimated time:' + twoLocsTime + 's</a></td></tr>';
                    alertMsg = alertMsg + directionsMsg;
                    alertMsg = alertMsg + '<tr><td  class="style1" colspan="2" align="left"><ul class="bulletcont"><li class="bullet"><span>' + alphabets[x + 1] + '</span></li></ul><ul class="bulletdesk"><li class="departhead">ARRIVE:</li><li class="desc">' + orgList[x + 1] + '</li><li class="desc">' + addressList[x + 1] + '</li></ul></td></tr>';
                    if ((x + 1) != result.resourceSets[0].resources[0].routeLegs.length)
                        alertMsg = alertMsg + '<tr style="height:15px"><td colspan="2"></td></tr><tr>';
                }
                //alertMsg = alertMsg + "Total Distance: " + totalDistance.toFixed(1) + "km \t Total Time: " + totalTime + "s"
                //                  alertMsg = alertMsg + "<b style='color:Blue'>" + orgList[tripLocs] + "</b><br>";
                //                  alertMsg = alertMsg + "<a>" + addressList[tripLocs] + "</a><br><br>";
                alertMsg = alertMsg + '</table>';
                var directionsDiv = document.getElementById('directionsDiv');
                var TotalRoute = "<b style='color:Green;'>Route:</b><b>" + totalDistance.toFixed(1) + " mi," + totalTime + "s</b><br>";
                //alertMsg = TotalRoute + alertMsg;
                directionsDiv.innerHTML = alertMsg;
                var divTotalDistance = document.getElementById('divTotalDistance');
                divTotalDistance.innerHTML = TotalRoute;
            }
        }
        function CallRestService(request) {
            var script = document.createElement("script");
            script.setAttribute("type", "text/javascript");
            script.setAttribute("src", request);
            document.body.appendChild(script);
        }
    </script>
    <form id="form1" action="Print.aspx">
    <div id="divTotalDistance" style="position: absolute; width: 700px; height: 30px;
        left: 20px; overflow: auto; font-size: 11px;">
    </div>
    <iframe id="frame1" width="700px" height="550px" frameborder="0" style="position: absolute;
        top: 30px;"></iframe>
    <div id="directionsDiv" style="position: absolute; width: 650px; left: 15px; top: 590px;
        overflow: auto; border: 1px; font-size: 11px;">
    </div>
    </form>
</body>
</html>
